CC=gcc
FC=gfortran
MKLROOT=/opt/intel/mkl

CCFLAG=-O3 -mtune=native -march=native -fopenmp -Wall -std=c99
FCFLAG=-O3 -mtune=native -march=native -fopenmp -Wall

LIB=-L../../lapack-3.9.1 -llapack -lrefblas -lm

all: clean RESGKL.o CGS2.o DGEBRDG_4_BISIDE.o ERR.o dbdsqru.o doqds.o dlartg6.o dlartg7.o dlas2u.o drot2.o dfma0.o RESGKL_MAIN.o fileinput_gkl oneone

%.o: lib/%.f
	${FC} ${FCFLAG} -c -o lib/$@ $<

%.o: lib/%.f90
	${FC} ${FCFLAG} -c -o lib/$@ $<

%.o: src/%.f90
	${FC} ${FCFLAG} -c -o src/$@ $<

dfma0.o:
	${CC} ${CCFLAG} -c -o lib/dfma0.o lib/dfma0.c

fileinput_gkl:
	${FC} ${FCFLAG} -o fileinput_gkl fileinput_gkl.f src/CGS2.o src/DGEBRDG_4_BISIDE.o src/RESGKL.o src/ERR.o lib/dbdsqru.o lib/doqds.o lib/dlartg6.o lib/dlartg7.o lib/dlas2u.o lib/drot2.o lib/dfma0.o src/RESGKL_MAIN.o ${LIB}

oneone:
	${CC} ${CCFLAG} -o oneone oneone.c

clean:
	rm -rf *.mod src/*.o lib/*.o fileinput_gkl oneone 
