module my_data
  implicit none
  INTEGER, ALLOCATABLE:: IAP(:), JA(:)
  Double precision, ALLOCATABLE:: A(:), DA(:,:)
  Integer mode
  integer, allocatable:: start_row(:)
  Integer m, n, nsv, ncv, opcount
  Double precision s0,s1
  INTEGER LWORK
  DOUBLE PRECISION, ALLOCATABLE:: WORK(:),BK(:,:),VK(:,:),UK(:,:),VPLUS(:),VM(:,:),UM(:,:)
end module my_data

SUBROUTINE SMALLCOND(LS,BD,BE)
  use my_data
  IMPLICIT NONE
  
  INTEGER LS,J
  DOUBLE PRECISION HALF,ONE,ZERO
  PARAMETER( HALF=0.5D+0, ONE=1.0D+0, ZERO=0.0D+0 )
  DOUBLE PRECISION BD(ncv),BE(ncv),EPS,TOL,TMP1
  DOUBLE PRECISION HUND
  PARAMETER (HUND = 100.0D0)
  DOUBLE PRECISION DLAMCH
  EXTERNAL DLAMCH
  
  EPS = DLAMCH( 'Precision' )
  TOL = HUND*EPS

  IF (LS .EQ. 0) THEN

     TMP1 = ABS(BD(1))
     DO J = 1, ncv-1
        IF (ABS(BE(J)) .LE. TOL*TMP1) THEN
           BE(J) = ZERO
        ENDIF
        TMP1 = ABS(BD(J+1))*(TMP1/(TMP1+ABS(BE(J))))
     ENDDO

  ELSE

     TMP1 = ABS(BD(ncv))
     DO J = ncv-1, 1, -1
        IF (ABS(BE(J)) .LE. TOL*TMP1) THEN
           BE(J) = ZERO
        ENDIF
        TMP1 = ABS(BD(J))*(TMP1/(TMP1+ABS(BE(J))))
     ENDDO

  ENDIF
  
  RETURN
  
END SUBROUTINE SMALLCOND

SUBROUTINE DTRF(Q,P,CPBK,BE)
  use my_data
  IMPLICIT NONE

  INTEGER I,J
  DOUBLE PRECISION Q(ncv,nsv),P(ncv,nsv),CPBK(ncv,ncv),BE(1,ncv)
  DOUBLE PRECISION CS1,SN1,CS2,SN2
  
  DO I=1,nsv
     DO J=ncv,I+1,-1
        CALL DLARTG(P(J-1,I),P(J,I),CS1,SN1,P(J-1,I))
        CALL DROT(nsv-I,P(J-1,I+1),ncv,P(J,I+1),ncv,CS1,SN1)
        CALL DROT(ncv,CPBK(1,J-1),1,CPBK(1,J),1,CS1,SN1)
        CALL DROT(N,VK(1,J-1),1,VK(1,J),1,CS1,SN1)

        CALL DLARTG(Q(J-1,I),Q(J,I),CS2,SN2,Q(J-1,I))
        CALL DROT(nsv-I,Q(J-1,I+1),ncv,Q(J,I+1),ncv,CS2,SN2)
        CALL DROT(ncv,CPBK(J-1,1),ncv,CPBK(J,1),ncv,CS2,SN2)
        CALL DROT(M,UK(1,J-1),1,UK(1,J),1,CS2,SN2)
        CALL DROT(1,BE(1,J-1),1,BE(1,J),1,CS2,SN2)
     ENDDO
  ENDDO

END SUBROUTINE DTRF

SUBROUTINE DTRF2(Q,P,CPBK,BE)
  use my_data
  IMPLICIT NONE

  INTEGER I,J
  DOUBLE PRECISION Q(ncv,nsv),P(ncv,nsv),CPBK(ncv,ncv),BE(1,ncv)
  DOUBLE PRECISION CS1,SN1,CS2,SN2
  
  DO I=1,nsv
     DO J=ncv,I+1,-1
        CALL DLARTG(Q(J-1,I),Q(J,I),CS2,SN2,Q(J-1,I))
        CALL DROT(nsv-I,Q(J-1,I+1),ncv,Q(J,I+1),ncv,CS2,SN2)
        CALL DROT(ncv,CPBK(1,J-1),1,CPBK(1,J),1,CS2,SN2)
        CALL DROT(M,UK(1,J-1),1,UK(1,J),1,CS2,SN2)
        CALL DROT(1,BE(1,J-1),1,BE(1,J),1,CS2,SN2)
        
        CALL DLARTG(P(J-1,I),P(J,I),CS1,SN1,P(J-1,I))
        CALL DROT(nsv-I,P(J-1,I+1),ncv,P(J,I+1),ncv,CS1,SN1)
        CALL DROT(ncv,CPBK(J-1,1),ncv,CPBK(J,1),ncv,CS1,SN1)
        CALL DROT(N,VK(1,J-1),1,VK(1,J),1,CS1,SN1)
     ENDDO
  ENDDO

END SUBROUTINE DTRF2

SUBROUTINE DTRF3(P,CPBK,BE)
  use my_data
  IMPLICIT NONE

  INTEGER I,J
  DOUBLE PRECISION P(ncv,nsv),CPBK(ncv,ncv),BE(1,ncv)
  DOUBLE PRECISION CS1,SN1,CS2,SN2
  
  DO I=1,nsv
     DO J=ncv,I+1,-1
        CALL DLARTG(P(J-1,I),P(J,I),CS1,SN1,P(J-1,I))
        CALL DROT(nsv-I,P(J-1,I+1),ncv,P(J,I+1),ncv,CS1,SN1)
        CALL DROT(ncv,CPBK(1,J-1),1,CPBK(1,J),1,CS1,SN1)
        CALL DROT(N,VK(1,J-1),1,VK(1,J),1,CS1,SN1)
     ENDDO
  ENDDO

  DO I=1,nsv
     DO J=ncv,I+1,-1
        CALL DLARTG(CPBK(J-1,I),CPBK(J,I),CS2,SN2,CPBK(J-1,I))
        CALL DROT(nsv-I,CPBK(J-1,I+1),ncv,CPBK(J,I+1),ncv,CS2,SN2)
        CALL DROT(M,UK(1,J-1),1,UK(1,J),1,CS2,SN2)
        CALL DROT(1,BE(1,J-1),1,BE(1,J),1,CS2,SN2)
     ENDDO
  ENDDO

END SUBROUTINE DTRF3

SUBROUTINE DTRF4(Q,CPBK,BE)
  use my_data
  IMPLICIT NONE

  INTEGER I,J
  DOUBLE PRECISION Q(ncv,nsv),CPBK(ncv,ncv),BE(1,ncv)
  DOUBLE PRECISION CS1,SN1,CS2,SN2
  
  DO I=1,nsv
     DO J=ncv,I+1,-1
        CALL DLARTG(Q(J-1,I),Q(J,I),CS1,SN1,Q(J-1,I))
        CALL DROT(nsv-I,Q(J-1,I+1),ncv,Q(J,I+1),ncv,CS1,SN1)
        CALL DROT(ncv,CPBK(1,J-1),1,CPBK(1,J),1,CS1,SN1)
        CALL DROT(M,UK(1,J-1),1,UK(1,J),1,CS1,SN1)
        CALL DROT(1,BE(1,J-1),1,BE(1,J),1,CS1,SN1)
     ENDDO
  ENDDO

  DO I=1,nsv
     DO J=ncv,I+1,-1
        CALL DLARTG(CPBK(J-1,I),CPBK(J,I),CS2,SN2,CPBK(J-1,I))
        CALL DROT(nsv-I,CPBK(J-1,I+1),ncv,CPBK(J,I+1),ncv,CS2,SN2)
        CALL DROT(N,VK(1,J-1),1,VK(1,J),1,CS2,SN2)
     ENDDO
  ENDDO

END SUBROUTINE DTRF4

SUBROUTINE RESGKL(J,LS,METHOD)
  use my_data
  use omp_lib
  IMPLICIT NONE

  integer LS

  INTEGER I,J,IINFO,METHOD,RANK
  DOUBLE PRECISION ONE,ZERO,TWO
  PARAMETER(ONE=1.0D+0,ZERO=0.0D+0,TWO=2.0D+0)
  DOUBLE PRECISION CDUMMY(1,1),BETA
  DOUBLE PRECISION CPBK(ncv,ncv),CPBK2(ncv,ncv),BD(ncv),BE(ncv)
  DOUBLE PRECISION WORK2(ncv*8)
  DOUBLE PRECISION Q(ncv,ncv),P(ncv,ncv)
  DOUBLE PRECISION DNRM2,DDOT

  VK(1:N,J+1) = VPLUS(1:N)
  DO WHILE(J < ncv)
     CALL av(VK(1:N,J+1),UK(1:M,J+1))
     CALL CGS2(UK(1:M,J+1),UK,M,J)
     BK(J+1,J+1) = DNRM2(M,UK(1:M,J+1),1)
     UK(1:M,J+1) = UK(1:M,J+1) / BK(J+1,J+1)
     CALL atv(UK(1:M,J+1), VPLUS)
     CALL CGS2(VPLUS,VK,N,J+1)

     BETA = DNRM2(N,VPLUS,1)
     IF(J < ncv - 1) THEN
        BK(J+1,J+2) = BETA
        VK(1:N,J+2) = VPLUS(1:N) / BETA
     ELSE
        VPLUS(1:N) = VPLUS(1:N) / BETA
     END IF
     J = J+1
  END DO
  J = nsv

  Q = ZERO
  DO I = 1,ncv
     Q(I,I) = ONE
  END DO
  P = ZERO
  DO I = 1,ncv
     P(I,I) = ONE
  END DO

  IF ( METHOD == 1 ) THEN
     ! with lapack QR

     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO

     IF(LS == 0) then

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL DGEMM('N','T',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)

        BK = ZERO
        DO I =1 ,nsv
           BK(I,I) = BD(I)
        END DO

        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

     ELSE

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(ncv+1-I,1),ncv,P(I,1),ncv) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL DGEMM('N','T',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)

        BK = ZERO
        DO I =1 ,nsv
           BK(I,I) = BD(ncv-I+1)
        END DO

        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

     ENDIF
     
  ELSE IF ( METHOD == 2 ) THEN
     ! with lapack QR
     ! reflector

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO

     IF(LS == 0) then

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)
        
        CALL DGEQR2P(ncv,nsv,P,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',N,ncv,nsv,P,ncv,BD,VK,N,WORK,IINFO )
        CALL DORM2R('R','N',ncv,ncv,nsv,P,ncv,BD,CPBK,ncv,WORK,IINFO )

        CALL DGEQR2P(ncv,nsv,Q,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',M,ncv,nsv,Q,ncv,BD,UK,M,WORK,IINFO )
        CALL DORM2R('L','T',ncv,nsv,nsv,Q,ncv,BD,CPBK,ncv,WORK,IINFO )

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DORM2R('R','N',1,ncv,nsv,Q,ncv,BD,BE,1,WORK,IINFO )

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

     ELSE

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)
        
        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        CPBK = TRANSPOSE(CPBK)
        CALL DGEQR2P(ncv,nsv,Q,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',M,ncv,nsv,Q,ncv,BD,UK,M,WORK,IINFO )
        CALL DORM2R('R','N',ncv,ncv,nsv,Q,ncv,BD,CPBK,ncv,WORK,IINFO )

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DORM2R('R','N',1,ncv,nsv,Q,ncv,BD,BE,1,WORK,IINFO )

        CALL DGEQR2P(ncv,nsv,P,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',N,ncv,nsv,P,ncv,BD,VK,N,WORK,IINFO )
        CALL DORM2R('L','T',ncv,nsv,nsv,P,ncv,BD,CPBK,ncv,WORK,IINFO )

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

     ENDIF

  ELSE IF ( METHOD == 3 ) THEN
     ! with lapack QR
     ! Givens

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO

     IF (LS == 0) THEN

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DTRF(Q,P,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

     ELSE

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CPBK = TRANSPOSE(CPBK)
        CALL DTRF2(Q,P,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

     ENDIF

  ELSE IF ( METHOD == 4 ) THEN
     ! with lapack QR
     ! Givens

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO

     IF (LS == 0) THEN

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DTRF3(P,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

     ELSE

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CPBK = TRANSPOSE(CPBK)
        CALL DTRF4(Q,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

     ENDIF

  ELSE IF ( METHOD == 5 ) THEN
     ! with lapack QR

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO

     IF (LS == 0) THEN

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)

        CALL MGS(Q,WORK2)
        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL MGS(P,WORK2)
        CALL DGEMM('N','N',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)

        CALL DGEMM('N','N',ncv,nsv,ncv,ONE,CPBK,ncv,P,ncv,ZERO,CPBK2,ncv)
        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=DDOT(ncv,CPBK2(1,I),1,Q(1,I),1)
        END DO

        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

     ELSE

        CALL DBDSQRU( 'U',ncv,ncv,ncv,0,BD,BE,P,ncv,Q,ncv,CDUMMY,ncv,WORK,IINFO )

        P = TRANSPOSE(P)

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        CALL MGS(Q,WORK2)
        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL MGS(P,WORK2)
        CALL DGEMM('N','N',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)

        CALL DGEMM('T','N',ncv,nsv,ncv,ONE,CPBK,ncv,Q,ncv,ZERO,CPBK2,ncv)
        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=DDOT(ncv,CPBK2(1,I),1,P(1,I),1)
        END DO

        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

     ENDIF
     
  ELSE IF ( METHOD == 6 ) THEN
     ! with OQDS
     
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO
     P = TRANSPOSE(P)

     IF (LS == 0) THEN
     
        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )

        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL DGEMM('N','N',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)
     
        BK = ZERO
        DO I =1 ,nsv
           BK(I,I) = BD(I)
        END DO
     
        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

        IF (RANK .LT. nsv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF

     ELSE

        CALL DOQDS( 'U',ncv,BD,BE,LS,RANK,Q,ncv,P,ncv,WORK,WORK2,IINFO )

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL DGEMM('N','N',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)
     
        BK = ZERO
        DO I =1 ,nsv
           BK(I,I) = BD(ncv-I+1)
        END DO
     
        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

        IF (RANK .LT. ncv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
        
     ENDIF
        
  ELSE IF ( METHOD == 7 ) THEN
     ! with OQDS
     ! reflector

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO
     P = TRANSPOSE(P)

     IF (LS == 0) THEN

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )

        CALL DGEQR2P(ncv,nsv,P,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',N,ncv,nsv,P,ncv,BD,VK,N,WORK,IINFO )
        CALL DORM2R('R','N',ncv,ncv,nsv,P,ncv,BD,CPBK,ncv,WORK,IINFO )

        CALL DGEQR2P(ncv,nsv,Q,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',M,ncv,nsv,Q,ncv,BD,UK,M,WORK,IINFO )
        CALL DORM2R('L','T',ncv,nsv,nsv,Q,ncv,BD,CPBK,ncv,WORK,IINFO )

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DORM2R('R','N',1,ncv,nsv,Q,ncv,BD,BE,1,WORK,IINFO )

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

        IF (RANK .LT. nsv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF

     ELSE

        CALL DOQDS( 'U',ncv,BD,BE,LS,RANK,Q,ncv,P,ncv,WORK,WORK2,IINFO )

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        CPBK = TRANSPOSE(CPBK)
        CALL DGEQR2P(ncv,nsv,Q,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',M,ncv,nsv,Q,ncv,BD,UK,M,WORK,IINFO )
        CALL DORM2R('R','N',ncv,ncv,nsv,Q,ncv,BD,CPBK,ncv,WORK,IINFO )
        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DORM2R('R','N',1,ncv,nsv,Q,ncv,BD,BE,1,WORK,IINFO )

        CALL DGEQR2P(ncv,nsv,P,ncv,BD,WORK,IINFO)
        CALL DORM2R('R','N',N,ncv,nsv,P,ncv,BD,VK,N,WORK,IINFO )
        CALL DORM2R('L','T',ncv,nsv,nsv,P,ncv,BD,CPBK,ncv,WORK,IINFO )

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

        IF (RANK .LT. ncv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
        
     ENDIF
     
  ELSE IF ( METHOD == 8 ) THEN
     ! with OQDS
     ! Givens

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO
     P = TRANSPOSE(P)

     IF (LS == 0) THEN

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DTRF(Q,P,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

        IF (RANK .LT. nsv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
     
     ELSE

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )

        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CPBK = TRANSPOSE(CPBK)
        CALL DTRF2(Q,P,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

        IF (RANK .LT. ncv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF

     ENDIF
     
  ELSE IF ( METHOD == 9 ) THEN
     ! with OQDS
     ! Givens

     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO
     P = TRANSPOSE(P)

     IF (LS == 0) THEN

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CPBK = TRANSPOSE(CPBK)
        CALL DTRF4(Q,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

        IF (RANK .LT. nsv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
        
     ELSE

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )

        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        BE(1:ncv) = ZERO
        BE(ncv) = BETA
        CALL DTRF3(P,CPBK,BE)

        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=CPBK(I,I)
        END DO

        CALL DCOPY(nsv,BE,1,BK(1,nsv+1),1)

        IF (RANK .LT. ncv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
        
     ENDIF

  ELSE IF ( METHOD == 10 ) THEN
     ! with OQDS
     
     CPBK = BK
     CALL DGEBRDG_4_BISIDE(nsv+1,BK,ncv,Q,P)
     DO I = 1,ncv
        BD(I) = BK(I,I)
     END DO
     DO I = 1,ncv-1
        BE(I) = BK(I,I+1)
     END DO
     P = TRANSPOSE(P)

     IF (LS == 0) THEN

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )
     
        CALL MGS(Q,WORK2)
        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL MGS(P,WORK2)
        CALL DGEMM('N','N',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)
     
        CALL DGEMM('N','N',ncv,nsv,ncv,ONE,CPBK,ncv,P,ncv,ZERO,CPBK2,ncv)
        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=DDOT(ncv,CPBK2(1,I),1,Q(1,I),1)
        END DO
     
        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

        IF (RANK .LT. nsv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
        
     ELSE

        CALL DOQDS( 'L',ncv,BD,BE,LS,RANK,P,ncv,Q,ncv,WORK,WORK2,IINFO )
     
        DO I = 1, ncv/2
           CALL DSWAP(ncv,Q(1,ncv+1-I),1,Q(1,I),1) !Q(1:ncv,I) = Q(1:ncv,ncv+1-I)
        END DO
        DO I = 1, ncv/2
           CALL DSWAP(ncv,P(1,ncv+1-I),1,P(1,I),1) !P(I,1:ncv) = P(ncv+1-I,1:ncv)
        END DO

        CALL MGS(Q,WORK2)
        CALL DGEMM('N','N',M,nsv,ncv,ONE,UK,M,Q,ncv,ZERO,UM,M)
        CALL DLACPY('A',M,nsv,UM,M,UK,M)
        CALL MGS(P,WORK2)
        CALL DGEMM('N','N',N,nsv,ncv,ONE,VK,N,P,ncv,ZERO,VM,N)
        CALL DLACPY('A',N,nsv,VM,N,VK,N)
     
        CALL DGEMM('T','N',ncv,nsv,ncv,ONE,CPBK,ncv,Q,ncv,ZERO,CPBK2,ncv)
        BK = ZERO
        DO I = 1,nsv
           BK(I,I)=DDOT(ncv,CPBK2(1,I),1,P(1,I),1)
        END DO
     
        CALL DAXPY(nsv,BETA,Q(ncv,1),ncv,BK(1,nsv+1),1)

        IF (RANK .LT. ncv) THEN
           DO I =1 ,nsv
              BK(I,nsv+1) = ZERO
           END DO
        ENDIF
        
     ENDIF

  END IF
  
  RETURN
END SUBROUTINE RESGKL
!
Subroutine av(xin, yout)
  Use my_data
  Use omp_lib
  Implicit None
  Integer i, j,thr_num
  Double precision, Dimension(n), Intent(in) :: xin
  Double precision, Dimension(m), Intent(out) :: yout
  Double precision  zero
  parameter (zero=0.0d0)
  EXTERNAL           DDOT
  double precision   DDOT

  s1 = omp_get_wtime()
  if (mode .eq. 0) then

!$OMP PARALLEL PRIVATE(i,thr_num,j)
     thr_num = omp_get_thread_num()
     do i=start_row(thr_num+1),start_row(thr_num+2)-1
        yout(i) = zero
        do j=IAP(i),IAP(i+1)-1
           yout(i) = yout(i)+(A(j))*xin(JA(j))
        enddo
     enddo
!$OMP END PARALLEL
     
  else

!$OMP PARALLEL DO
     do i=1,M
        yout(i) = ddot(n,DA(1,i),1,xin,1)
     enddo
!$OMP END PARALLEL DO

  end if
  s0 = s0 + (omp_get_wtime() - s1)
  
  opcount = opcount + 1
  return
End Subroutine av
!
Subroutine atv(xin, yout)
  Use my_data
  Use omp_lib
  Implicit None
  Integer i, j,thr_num
  Double precision, Dimension(m), Intent(in) :: xin
  Double precision, Dimension(n), Intent(out) :: yout
  Double precision  zero
  parameter (zero=0.0d0)

  s1 = omp_get_wtime()
  if (mode .eq. 0) then

     yout=zero

!$OMP PARALLEL PRIVATE(i,thr_num,j) REDUCTION(+:yout)
     thr_num = omp_get_thread_num()
     do i=start_row(thr_num+1),start_row(thr_num+2)-1
        do j=IAP(i),IAP(i+1)-1
           yout(JA(j))=yout(JA(j))+(A(j))*xin(i)
        enddo
     enddo
!$OMP END PARALLEL
     
  else

     yout=zero

!$OMP PARALLEL DO REDUCTION(+:yout)
     do i=1,M
        call daxpy(n,xin(i),DA(1,i),1,yout,1)
     enddo
!$OMP END PARALLEL DO

  end if
  s0 = s0 + (omp_get_wtime() - s1)

  opcount = opcount + 1
  return
End Subroutine atv


